using System;
using System.Collections.Generic;
using System.Text;
using Telerik.WinControls.UI;

namespace RadListBoxBindingExample
{
    public class BEListBox : RadListBox
    {
        private object selectedObject;

        public BEListBox()
        {
            ListBoxElement.ItemDataBound += new ItemDataBoundEventHandler(ListBoxElement_ItemDataBound);
        }

        protected override void OnSelectedValueChanged(EventArgs e)
        {
            base.OnSelectedValueChanged(e);
            RadListBoxItem lI = SelectedItem as RadListBoxItem;
            if (lI != null)
            {
                SelectedObject = lI.Tag;
            }
        }

        void ListBoxElement_ItemDataBound(object sender, ItemDataBoundEventArgs e)
        {
            RadListBoxItem rI = e.DataBoundItem as RadListBoxItem;
            if (rI != null)
            {
                rI.Tag = e.DataItem;
            }
        }

        public object SelectedObject
        {
            get
            {
                return selectedObject;
            }
            set
            {
                selectedObject = value;
            }
        }

        public override string ThemeClassName
        {
            get
            {
                return typeof(RadListBox).FullName;
            }
        }      
    }   
}
